def num_to_isotope(n, num_h):
  """ Given integer 0 <= n <= 2**num_h, return corresponding isotopes and masses. """
  if not type(n) is int or n < 0 or not type(num_h) is int or  n > 2**num_h - 1:
    return TypeError("Input integers n, num_h such that  0 <= n <= 2**num_h.")
  
  # Binary representation: 5 digits, no leading '0b'; 0 -> h, 1 -> d
  isotopes = str(bin(n)[2:].zfill(num_h)).replace('0', 'h').replace('1', 'd')

  masses = [12.01, 12.01, 12.01, 16.00, 16.00]
  for atom in isotopes:
    if atom == 'h':
      masses.append(1.008)
    elif atom == 'd':
      masses.append(2.014)
  return {isotopes : masses}

lig_mass = dict()
num_h = 5
for n in range(2**num_h):
  lig_mass.update(num_to_isotope(n, num_h))

print(lig_mass)
